﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;

namespace extensionMethodsExercise
{
    class Program
    {
        static void Main()
        {
            IList<int> list = new[] { 4, 6, 4, 99, 2, 2, 1 };
            list.Sort().Unique().Print(", ");

            list.Unique((i, j) => i < j).Print(", ");
            String name = "Anders";
            Console.WriteLine(name);

            name.Print();

            String sentence = "My name is Anders"; // String implements IEnumerable<char>
            sentence.Sort().Print(", ");

            list.Sort();

            list.Sort((i, j) => j - i).Concat(", ").Print();
            String str2 = "Anders is my name";
            str2.Sort().Unique().Take(3).Concat(" ").Print();

            ExtensionMethods.GetRandom(10, 8).Sort().Concat(", ").Print();
            ExtensionMethods.GetRandom(10, 8).Sort().Print(", ");
            //IList<Color> colors = new[] { Color.AliceBlue};
            //colors.Sort(); // Color does not implement Comparable<Color>

            var listlist = list.Split(3);
            foreach (var li in listlist)
            {
                Console.WriteLine(li.Concat(", "));
            }
        }
    }
}